com.tibco.n2.service.adapter.binding

## Interface DirectoryService

- All Known Implementing Classes:
    DirectoryService

      public interface DirectoryService

  Provides access to the Directory Engine DirectoryService interfaces.

  ©2012 TIBCO Software Inc. All Rights Reserved.
  Since:

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `deleteContainer(long containerId, boolean deleteResources)` Deletes the configuration of the identified LDAP Container.
    `com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse` | `executeLdapQuery(java.lang.String ldapAlias, java.lang.String baseDn, java.lang.String ldapQuery)` Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null).
    `com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse` | `executeLdapQuery(java.lang.String ldapAlias, java.lang.String baseDn, java.lang.String ldapQuery, com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum aScope)` Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null).
    `com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse` | `executeLdapQuery(java.lang.String ldapAlias, java.lang.String baseDn, java.lang.String ldapQuery, com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum aScope, int pageSize, java.lang.String bookmark)` Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null).
    `com.tibco.bpm.de.api.directory.GetCandidateDetailResponseDocument.GetCandidateDetailResponse` | `getCandidateDetail(java.lang.String ldapAlias, java.lang.String ldapDn, com.tibco.bpm.de.api.base.XmlLdapEntryId[] secondaryRefArray, long containerId)` Returns the detail (including LDAP attribute values) for the candidate Resource identified by the request.
    `com.tibco.bpm.de.api.directory.GetLdapEntryResponseDocument.GetLdapEntryResponse` | `getLdapEntry(java.lang.String ldapAlias, java.lang.String ldapDn, com.tibco.bpm.de.api.directory.GetLdapEntryDocument.GetLdapEntry.Attribute[] attributeArray)` Returns the named attributes from the LDAP entry identified by the given LDAP alias and DN.
    `com.tibco.bpm.de.api.directory.ListAttributeNamesResponseDocument.ListAttributeNamesResponse` | `listAttributeNames(java.lang.String ldapAlias, java.lang.String baseDn, java.lang.String ldapQuery, int sampleSize)` Identifies the names of the LDAP attributes belonging the entries identified by evaluating the given query against the LDAP Connection identified by its alias.
    `com.tibco.bpm.de.api.directory.ListAttributeNamesResponseDocument.ListAttributeNamesResponse` | `listAttributeNames(java.lang.String ldapAlias, java.lang.String baseDn, java.lang.String ldapQuery, com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum seachScope, int sampleSize)` Identifies the names of the LDAP attributes belonging the entries identified by evaluating the given query against the LDAP Connection identified by its alias.
    `com.tibco.bpm.de.api.directory.ListCandidateResourcesResponseDocument.ListCandidateResourcesResponse` | `listCandidateResources(long containerId, com.tibco.bpm.de.api.base.XmlCandidateChoice.Enum include)` Lists the LDAP Entries, from the identified LDAP Container, that are candidates for Resources.
    `com.tibco.bpm.de.api.directory.ListCandidateResourcesResponseDocument.ListCandidateResourcesResponse` | `listCandidateResources(long containerId, com.tibco.bpm.de.api.base.XmlCandidateChoice.Enum include, int pageSize, java.lang.String bookmark)` Lists the LDAP Entries, from the identified LDAP Container, that are candidates for Resources.
    `com.tibco.bpm.de.api.base.XmlContainer[]` | `listContainers()` Lists the full details of all configured LDAP Containers - including those that have been flagged as inactive.
    `com.tibco.bpm.de.api.directory.ListLdapConnectionsResponseDocument.ListLdapConnectionsResponse.LdapConnection[]` | `listLdapConnections()` Lists the LDAP Connection Shared Resources that are available to AMX-BPM.
    `long` | `saveContainer(long id, java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapGroupSource aPrimaryGroupLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Updates an existing LdapContainer (identified by the given id value).
    `long` | `saveContainer(long id, java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapQuerySource aPrimaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Updates an existing LdapContainer (identified by the given id value).
    `long` | `saveContainer(long id, java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapSource primaryLdap, com.tibco.bpm.de.api.base.XmlLdapSource[] secondaryLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Updates an existing LdapContainer (identified by the given id value).
    `long` | `saveContainer(java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapGroupSource aPrimaryGroupLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Save a new LdapContainer configuration; where the primary LDAP Source is for an LDAP Group.
    `long` | `saveContainer(java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapQuerySource aPrimaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap, com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Save a new LdapContainer configuration; where the primary LDAP Source is for an LDAP Query.
    `long` | `saveContainer(java.lang.String name, java.lang.String description, com.tibco.bpm.de.api.base.XmlLdapSource primaryLdap, com.tibco.bpm.de.api.base.XmlLdapSource[] secondaryLdap, com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)` Save a new LdapContainer configuration.

- - ### Method Detail

    - #### listLdapConnections

          com.tibco.bpm.de.api.directory.ListLdapConnectionsResponseDocument.ListLdapConnectionsResponse.LdapConnection[] listLdapConnections()
                                                                                                                                       throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                                              com.tibco.n2.de.services.SecurityFault

      Lists the LDAP Connection Shared Resources that are available to AMX-BPM. The result includes the provider URL to which the connections refer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getLdapEntry

          com.tibco.bpm.de.api.directory.GetLdapEntryResponseDocument.GetLdapEntryResponse getLdapEntry(java.lang.String ldapAlias,
                                                                                                        java.lang.String ldapDn,
                                                                                                        com.tibco.bpm.de.api.directory.GetLdapEntryDocument.GetLdapEntry.Attribute[] attributeArray)
                                                                                                 throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                        com.tibco.n2.de.services.SecurityFault

      Returns the named attributes from the LDAP entry identified by the given LDAP alias and DN. If the given attributeArray is `null`, or empty, the result will include all attributes.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `ldapDn` - the DN of the LDAP entry whose attributes are to be returned.
        `attributeArray` - the names of the LDAP attributes to be returned.
      Returns:
        the values of the identified LDAP entry.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### executeLdapQuery

          com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse executeLdapQuery(java.lang.String ldapAlias,
                                                                                                                    java.lang.String baseDn,
                                                                                                                    java.lang.String ldapQuery)
                                                                                                             throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                    com.tibco.n2.de.services.SecurityFault

      Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null). The response will list the DNs of those entries evaluated by the query.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `baseDn` - the optional base-DN from which the query is to be performed.
        `ldapQuery` - the LDAP query to be executed.
      Returns:
        the resulting DN of the LDAP query.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### executeLdapQuery

          com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse executeLdapQuery(java.lang.String ldapAlias,
                                                                                                                    java.lang.String baseDn,
                                                                                                                    java.lang.String ldapQuery,
                                                                                                                    com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum aScope)
                                                                                                             throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                    com.tibco.n2.de.services.SecurityFault

      Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null). The response will list the DNs of those entries evaluated by the query.

      A search-scope must be specified to limit the depth to which the search is performed.

      - SUBTREE - elements directly within, and below, the Base-DN level are searched.
      - ONELEVEL - only the elements directly within the Base-DN level are searched.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `baseDn` - the optional base-DN from which the query is to be performed.
        `ldapQuery` - the LDAP query to be executed.
        `aScope` - the depth to which the search should be performed.
      Returns:
        the resulting DN of the LDAP query.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### executeLdapQuery

          com.tibco.bpm.de.api.directory.ExecuteLdapQueryResponseDocument.ExecuteLdapQueryResponse executeLdapQuery(java.lang.String ldapAlias,
                                                                                                                    java.lang.String baseDn,
                                                                                                                    java.lang.String ldapQuery,
                                                                                                                    com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum aScope,
                                                                                                                    int pageSize,
                                                                                                                    java.lang.String bookmark)
                                                                                                             throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                    com.tibco.n2.de.services.SecurityFault

      Executes a given LDAP Query against the LDAP Connection identified by its alias, and restricted to a given Base DN (may be null). The response will list the DNs of those entries evaluated by the query.

      A search-scope must be specified to limit the depth to which the search is performed.

      - SUBTREE - elements directly within, and below, the Base-DN level are searched.
      - ONELEVEL - only the elements directly within the Base-DN level are searched.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `baseDn` - the optional base-DN from which the query is to be performed.
        `ldapQuery` - the LDAP query to be executed.
        `aScope` - the depth to which the search should be performed.
        `pageSize` - maximum number of results to be returned in result set
        `bookmark` - marker indicating current page in the result set - must be Base64 encoded
      Returns:
        the resulting DN of the LDAP query.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### listAttributeNames

          com.tibco.bpm.de.api.directory.ListAttributeNamesResponseDocument.ListAttributeNamesResponse listAttributeNames(java.lang.String ldapAlias,
                                                                                                                          java.lang.String baseDn,
                                                                                                                          java.lang.String ldapQuery,
                                                                                                                          int sampleSize)
                                                                                                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                          com.tibco.n2.de.services.SecurityFault

      Identifies the names of the LDAP attributes belonging the entries identified by evaluating the given query against the LDAP Connection identified by its alias. This is used to aid the association of LDAP Attributes to Resource Attributes. The response can also include a sample collection of LDAP Entries for which the values of the named attributes are listed. The number of sample entries is specified in the request.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `baseDn` - the optional base-DN from which the query is to be performed.
        `ldapQuery` - the LDAP query to identify the entries from which attributes are to be collated.
        `sampleSize` - the number of LDAP entries from which sample values are to be retrieved.
      Returns:
        the names, and values, of the LDAP attributes.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### listAttributeNames

          com.tibco.bpm.de.api.directory.ListAttributeNamesResponseDocument.ListAttributeNamesResponse listAttributeNames(java.lang.String ldapAlias,
                                                                                                                          java.lang.String baseDn,
                                                                                                                          java.lang.String ldapQuery,
                                                                                                                          com.tibco.bpm.de.api.base.XmlLdapSearchScope.Enum seachScope,
                                                                                                                          int sampleSize)
                                                                                                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                          com.tibco.n2.de.services.SecurityFault

      Identifies the names of the LDAP attributes belonging the entries identified by evaluating the given query against the LDAP Connection identified by its alias. This is used to aid the association of LDAP Attributes to Resource Attributes. The response can also include a sample collection of LDAP Entries for which the values of the named attributes are listed. The number of sample entries is specified in the request.
      Parameters:
        `ldapAlias` - the alias of the LDAP Connection to be used.
        `baseDn` - the optional base-DN from which the query is to be performed.
        `ldapQuery` - the LDAP query to identify the entries from which attributes are to be collated.
        `seachScope` - allows the caller to specify the depth to which the search will be performed. One of ONELEVEL or SUBTREE values can be specified.
        `sampleSize` - the number of LDAP entries from which sample values are to be retrieved.
      Returns:
        the names, and values, of the LDAP attributes.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### listContainers

          com.tibco.bpm.de.api.base.XmlContainer[] listContainers()
                                                           throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                  com.tibco.n2.de.services.SecurityFault

      Lists the full details of all configured LDAP Containers - including those that have been flagged as inactive. An inactive Container is one that has been marked for deletion but still has Resources associated with it.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### saveContainer

          long saveContainer(java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapSource primaryLdap,
                             com.tibco.bpm.de.api.base.XmlLdapSource[] secondaryLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Save a new LdapContainer configuration. For backward compatibility only.
      Parameters:
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `primaryLdap` - the primary LdapSource configuration.
        `secondaryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryGroupLdapSource or XmlSecondaryTreeLdapSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the newly created LdapContainer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`
      See Also:
        `saveContainer(String, String, XmlLdapGroupSource, XmlSecondaryLdapQuerySource[], XmlSecondaryLdapGroupSource[], XmlRestrictedOrg[])`, `saveContainer(String, String, XmlLdapQuerySource, XmlSecondaryLdapQuerySource[], XmlSecondaryLdapGroupSource[], XmlRestrictedOrg[])`

    - #### saveContainer

          long saveContainer(java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapQuerySource aPrimaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Save a new LdapContainer configuration; where the primary LDAP Source is for an LDAP Query.
      Parameters:
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `aPrimaryQueryLdap` - the primary LdapSource configuration.
        `aSecondaryQueryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapQuerySource.
        `aSecondaryGroupLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapGroupSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the newly created LdapContainer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### saveContainer

          long saveContainer(java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapGroupSource aPrimaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Save a new LdapContainer configuration; where the primary LDAP Source is for an LDAP Group.
      Parameters:
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `aPrimaryGroupLdap` - the primary LdapSource configuration.
        `aSecondaryQueryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapQuerySource.
        `aSecondaryGroupLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapGroupSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the newly created LdapContainer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### saveContainer

          long saveContainer(long id,
                             java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapSource primaryLdap,
                             com.tibco.bpm.de.api.base.XmlLdapSource[] secondaryLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Updates an existing LdapContainer (identified by the given id value). The response is the same ID value.
      Parameters:
        `id` - the primary key ID for the LdapContainer to be updated.
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `primaryLdap` - the primary LdapSource configuration.
        `secondaryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryGroupLdapSource or XmlSecondaryTreeLdapSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the updated LdapContainer - same as given ID value.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### saveContainer

          long saveContainer(long id,
                             java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapQuerySource aPrimaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Updates an existing LdapContainer (identified by the given id value). The response is the same ID value.
      Parameters:
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `aPrimaryQueryLdap` - the primary LdapSource configuration.
        `aSecondaryQueryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapQuerySource.
        `aSecondaryGroupLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapGroupSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the newly created LdapContainer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### saveContainer

          long saveContainer(long id,
                             java.lang.String name,
                             java.lang.String description,
                             com.tibco.bpm.de.api.base.XmlLdapGroupSource aPrimaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapQuerySource[] aSecondaryQueryLdap,
                             com.tibco.bpm.de.api.base.XmlSecondaryLdapGroupSource[] aSecondaryGroupLdap,
                             com.tibco.bpm.de.api.base.XmlRestrictedOrg[] restrictedOrg)
                      throws com.tibco.n2.de.services.DirectoryEngineFault,
                             com.tibco.n2.de.services.SecurityFault

      Updates an existing LdapContainer (identified by the given id value). The response is the same ID value.
      Parameters:
        `name` - the name to be assigned to the LdapContainer.
        `description` - the optional description for the LdapContainer.
        `aPrimaryGroupLdap` - the primary LdapSource configuration.
        `aSecondaryQueryLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapQuerySource.
        `aSecondaryGroupLdap` - the optional array of secondary LdapSource configurations. This should be an array of XmlSecondaryLdapGroupSource.
        `restrictedOrg` - the optional collection of Organisation identifiers to which the LdapContainer will be restricted.
      Returns:
        the ID of the newly created LdapContainer.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### listCandidateResources

          com.tibco.bpm.de.api.directory.ListCandidateResourcesResponseDocument.ListCandidateResourcesResponse listCandidateResources(long containerId,
                                                                                                                                      com.tibco.bpm.de.api.base.XmlCandidateChoice.Enum include)
                                                                                                                               throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                                      com.tibco.n2.de.services.SecurityFault

      Lists the LDAP Entries, from the identified LDAP Container, that are candidates for Resources. The response may, if requested, include entries for which Resources already exist (indicated in the response by including their GUID). Each entry in the response will carry the alias and DN of each LDAP Source, within the LDAP Container, from which it was derived. If the response is to include existing Resources, those Resources that were originally derived from the LDAP Container, but can no longer be resolved, are highlighted with an error code. Those candidates for which multiple entries were found in a secondary LDAP Source will indicate how many "duplicates" were found in that secondary LDAP Source. This may occur due to the inaccuracy of the foreign-key mappings that link entries in the primary LDAP Source to those of a secondary LDAP Source.
      Parameters:
        `containerId` - the ID of the LDAP Container from which candidates are to be evaluated.
        `include` - `true` if existing resources are to be included.
      Returns:
        the list of resource candidates.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### listCandidateResources

          com.tibco.bpm.de.api.directory.ListCandidateResourcesResponseDocument.ListCandidateResourcesResponse listCandidateResources(long containerId,
                                                                                                                                      com.tibco.bpm.de.api.base.XmlCandidateChoice.Enum include,
                                                                                                                                      int pageSize,
                                                                                                                                      java.lang.String bookmark)
                                                                                                                               throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                                      com.tibco.n2.de.services.SecurityFault

      Lists the LDAP Entries, from the identified LDAP Container, that are candidates for Resources. The response may, if requested, include entries for which Resources already exist (indicated in the response by including their GUID). Each entry in the response will carry the alias and DN of each LDAP Source, within the LDAP Container, from which it was derived. If the response is to include existing Resources, those Resources that were originally derived from the LDAP Container, but can no longer be resolved, are highlighted with an error code. Those candidates for which multiple entries were found in a secondary LDAP Source will indicate how many "duplicates" were found in that secondary LDAP Source. This may occur due to the inaccuracy of the foreign-key mappings that link entries in the primary LDAP Source to those of a secondary LDAP Source.
      Parameters:
        `containerId` - the ID of the LDAP Container from which candidates are to be evaluated.
        `include` - `true` if existing resources are to be included.
        `pageSize` - maximum number of results to be returned in result set
        `bookmark` - marker indicating current page in the result set - must be Base64 encoded
      Returns:
        the list of resource candidates.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### getCandidateDetail

          com.tibco.bpm.de.api.directory.GetCandidateDetailResponseDocument.GetCandidateDetailResponse getCandidateDetail(java.lang.String ldapAlias,
                                                                                                                          java.lang.String ldapDn,
                                                                                                                          com.tibco.bpm.de.api.base.XmlLdapEntryId[] secondaryRefArray,
                                                                                                                          long containerId)
                                                                                                                   throws com.tibco.n2.de.services.DirectoryEngineFault,
                                                                                                                          com.tibco.n2.de.services.SecurityFault

      Returns the detail (including LDAP attribute values) for the candidate Resource identified by the request. The candidate Resource details of the request can be taken from an entry in the response of the listCandidateResources(). operation. The attributes include in the response will include:
      - Those to which Resource Attribute are mapped.
      - Those used to construct the names of derived Resources.
      - Those used to create foreign key references between secondary and primary LdapSources.
      If the request parameters identify an existign Resource, the response will include the GUID of that Resource.
      Parameters:
        `ldapAlias` - the LDAP alias from the primary LDAP source of the resource candidate.
        `ldapDn` - the DN of the primary LDAP source of the resource candidate.
        `secondaryRefArray` - the secondary LDAP source references of the resource candidate - may be `null`.
        `containerId` - the Ldap Container from which the candidate is taken.
      Returns:
        the resource candidate detail.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

    - #### deleteContainer

          boolean deleteContainer(long containerId,
                                  boolean deleteResources)
                           throws com.tibco.n2.de.services.DirectoryEngineFault,
                                  com.tibco.n2.de.services.SecurityFault

      Deletes the configuration of the identified LDAP Container. An LDAP Container can only be deleted if it no longer has any Resources associated with it. If the attribute "delete-resources" is true, and the caller has the required privileges for either of the system action "resourceAdmin" or "deleteResourceAdmin", any associated resources will be deleted before the LDAP Container is deleted.

      The response will indicate the success (true or false). In reality, the response will always indicate success; any failure will be indicated by an fault being raised.

      Parameters:
        `containerId` - the ID of the Ldap Container to be deleted.
        `deleteResources` - `true` if associated resources should also be deleted.
      Returns:
        `true` if the Ldap Container was deleted.
      Throws:
        `com.tibco.n2.de.services.DirectoryEngineFault`
        `com.tibco.n2.de.services.SecurityFault`

Copyright © 2018 TIBCO Software Inc. All Rights Reserved.